/* wybieramy typ kalkulatora */
//#define USE_TI89
//#define USE_TI92PLUS
#define USE_V200

/* uywamy optymalizowanych wywoa funkcji ROM */
#define OPTIMIZE_ROM_CALLS

/* program bdzie mniejszy */
#define NO_EXIT_SUPPORT

#include <tigcclib.h>

void
delay(void)
{
	long int i = 0;
	for (; i < 100000; i++)
		i++;
}

void
_main(void)
{
	void *savescreen = NULL;	/* wskanik do pamici przechowujcej kopi ekranu */
	int i;

	if (!(savescreen = malloc(LCD_SIZE))) {	/* przydzielamy pami */
		ST_helpMsg("Brak wystarczajacej ilosci pamieci!");
		return;
	}

	if (!GrayOn()) {	/* wczamy obsug wywietlania w odcieniach szaroci */
		ST_helpMsg("Nie mog wczy obsugi ekranu!");
		return;
	}
	LCD_save(savescreen);	/* zapiszmy kopi ekranu */

	memset(GetPlane(LIGHT_PLANE), 0x00, LCD_SIZE);	/* czycimy ekran */
	memset(GetPlane(DARK_PLANE), 0x00, LCD_SIZE);	/* czycimy ekran */

	for (i = 0; i < 10000; i++) {

		/* ustawiamy losowo wybrany pixel na losow warto */
		*(unsigned char *) (GetPlane(DARK_PLANE) + random(LCD_SIZE)) =
		    random(0xff);

	}

	for (i = 0; i < 2000; i++) {

		/* rysujemy lini o losowym pocztku i kocu */
		DrawLine(random(240), random(128), random(240), random(128),
			 A_REPLACE);

	}

	FontSetSys(F_6x8);	/* ustawiamy rozmiar czcionki */

	for (i = 0; i < 100; i++) {

		/* wypisujemy na ekranie kolorem przeciwnym do koloru ta */
		DrawStrXY(random(240), random(128), "*", A_REVERSE);
		delay();

	}

	/* rysujemy 3 trjkty... ktre wyczyszcz cay ekran */
	for (i = 128; i >= 0; i--)
		DrawLine(120, 128, 0, i, A_REVERSE);
	for (i = 0; i < 240; i++)
		DrawLine(120, 128, i, 0, A_REVERSE);
	for (i = 0; i < 128; i++)
		DrawLine(120, 128, 240, i, A_REVERSE);

	ngetchx();		/* czekamy na klawisz */

	GrayOff();		/* wyczamy obsug ekranu */
	LCD_restore(savescreen);	/* przywrmy zawarto wywietlacza */
	free(savescreen);	/* zwalniamy pami */
}
